#include <bits/stdc++.h>
using namespace std;
#define TLHAdepzais1tg ios_base::sync_with_stdio(0);cin.tie();cout.tie(0);
#define ll long long
#define N 100007
#define fi first
#define se second
#define pii pair<ll,ll>
#define str string
int n,m,k,x;
string s,s2[N];
void sub1()
{
    str s3=s2[1];
    str xau,xau2;
    sort(s3.begin(),s3.end());
    for(int i=0;i<s.size();i++)
    {
        if(s[i]=='#')
        {
            xau=s.substr(i,s.size()-(i));
            xau2=s.substr(0,i);
        }
    }
    int cnt=0;
    for(char ch:s3)
    {
        cnt++;
        str xau3=xau;
        xau3.erase(0,1);
        xau3=ch+xau3;
        str xau4=xau2+xau3;
        if(cnt==x)
        {
            cout<<xau4;
            break;
        }
    }
}
int main()
{
    TLHAdepzais1tg;
    if(fopen("fword.inp","r"))
    {
        freopen("fword.inp","r",stdin);
        freopen("fword.out","w",stdout);
    }
    cin>>n>>m>>k>>x;
    cin>>s;
    for(int i=1;i<=m;i++)
    {
        cin>>s2[i];
    }
    sub1();
    return 0;
}

